(*
  ShareMemRep Version: 1.0
  =========================
   - Aimingoo (aim@263.net)
   - 2003.08.05
   - Free and OpenSource
*)

unit ShareMemRep;

interface

implementation

uses
  Windows;

var
  ExeName: array [0..255] of char;
  hExe: HModule;
  OldMemMgr: TMemoryManager;
  MemMgr: TMemoryManager;
  _GetMemoryManager: procedure (var MemMgr: TMemoryManager);

exports
  GetMemoryManager;


initialization
  if IsLibrary then
  begin
    GetModuleFileName(0, @ExeName, 255);
    GetModuleHandle(@ExeName);
    _GetMemoryManager := GetProcAddress(hExe, 'GetMemoryManager');
    _GetMemoryManager(MemMgr);

    GetMemoryManager(OldMemMgr);
    SetMemoryManager(MemMgr);
  end;

finalization
  if IsLibrary then
    SetMemoryManager(OldMemMgr);

end.